<template>
    <div class="edit-view">
        <el-form
            :model="formData"
            :rules="rules"
            ref="form"
            label-width="80px"
            label-position="right"
            size="small"
            style="max-width: 500px;"
        >
            <el-form-item prop="userId" label="用户ID">
                <el-input v-model="formData.userId"></el-input>
            </el-form-item>
            <el-form-item prop="transactionType" label="交易类型">
                <el-select v-model="formData.transactionType" clearable filterable placeholder="请选择">
                    <el-option
                        v-for="item in transactionTypeOptions"
                        :key="item.value"
                        :label="item.label"
                        :value="item.value"
                    >
                    </el-option>
                </el-select>
            </el-form-item>
            <el-form-item prop="amount" label="交易金额">
                <el-input-number type="number" v-model="formData.amount"></el-input-number>
            </el-form-item>
            <el-form-item prop="payMethod" label="支付方式">
                <el-select v-model="formData.payMethod" clearable filterable placeholder="请选择">
                    <el-option
                        v-for="item in payMethodOptions"
                        :key="item.value"
                        :label="item.label"
                        :value="item.value"
                    >
                    </el-option>
                </el-select>
            </el-form-item>
            <el-form-item prop="transactionId" label="交易单号">
                <el-input v-model="formData.transactionId"></el-input>
            </el-form-item>
            <el-form-item prop="remark" label="备注">
                <el-input v-model="formData.remark"></el-input>
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving" type="primary">保存</el-button>
                <el-button @click="onDelete" :loading="saving" type="danger" v-if="formData.id">删除 </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
export default {
    name: 'CommissionRecordEdit',
    created() {
        if (this.$route.query.id) {
            this.$http
                .get('commissionRecord/get/' + this.$route.query.id)
                .then(res => {
                    this.formData = res;
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        }
    },
    data() {
        return {
            saving: false,
            formData: {},
            rules: {
                transactionType: [
                    {
                        required: true,
                        message: '请输入交易类型',
                        trigger: 'blur'
                    }
                ],
                amount: [
                    {
                        required: true,
                        message: '请输入交易金额',
                        trigger: 'blur'
                    }
                ]
            },
            transactionTypeOptions: [
                { label: '提现', value: 'TIXIAN' },
                { label: '收入', value: 'INCOME' },
                { label: '退款', value: 'REFUND' }
            ],
            payMethodOptions: [
                { label: '微信', value: 'WEIXIN' },
                { label: '余额', value: 'YUE' }
            ]
        };
    },
    methods: {
        onSave() {
            this.$refs.form.validate(valid => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            let data = { ...this.formData };

            this.saving = true;
            this.$http
                .post('/commissionRecord/save', data, { body: 'json' })
                .then(res => {
                    this.saving = false;
                    this.$message.success('成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/commissionRecord/del/${this.formData.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
